#!C:\Perl\bin\perl 

use strict;

my $src = "SimpleNode.java";
my $new = "__tmp.java";
open (IN, "<$src") || die "Cannot open $src for reading";
open (OUT, ">$new") || die "Cannot open $new for writing";

while (<IN>)
{
#    print OUT $_;
    s/public class SimpleNode implements Node/public class SimpleNode implements Node, Cloneable/;
    print OUT $_;
    last if (/public class SimpleNode implements Node/);    
}

print OUT <<EOM;
/** Added on the fly by the perl script
    Provides a way to store a token for a given node. It frees us from declaring a new class instead.
    Mandatory for IDs, useful for aggregates, etc.
**/
    
  protected Token tag;

  protected SimpleNode()
    {
      super();
    }
	
  public Token getTag()
    {
      return tag;
    }

  public void setTag(Token tok)
    {
      this.tag = tok;
    }

  public int getID()
   {
  return this.id;
   }

  protected Object clone()
   {
     //     SimpleNode freshNode = new SimpleNode( this.id );
     try
       {
	 System.out.println("Cloning " + this);  
	 SimpleNode freshNode = (SimpleNode) getClass().newInstance();
	 freshNode.setTag( this.getTag() );
	 // System.out.println("Cloning " + this);
	 return freshNode;
       }
     catch(Exception e)
       {
	 throw new RuntimeException("Failure in cloning " + this);
       }
   }

  protected static SimpleNode makeNode( int id)
  {
     return new SimpleNode(id);
  }   

EOM

while (<IN>)
{
    print OUT $_;
}

close(IN);
close(OUT);

rename( $new, $src) || die "Cannot rename $new to $src!";

